from Library import *
#----------------------------------------------------------------
# Alles l”schen
#
DeleteAll(1)        

#----------------------------------------------------------------

szr=2000
hsr=szr/2
frames=szr*30
xsize=2048
abst=4.5

NumPics=218

bpy.context.scene.frame_end = frames
bpy.context.scene.view_settings.exposure = 3.48485
bpy.ops.object.light_add(type='SUN', radius=1, align='WORLD', location=(0, 0, 0))

Cameras=NewCollection("Cameras")
cam=AddCamera("Camera")
MoveObjToCollection(Cameras,cam)
#cam=Get_Active_Cam()
Set_Active_Cam_ID(cam)    
cam.data.lens = 25
#cam.data.type = 'PANO'
cam.data.type = 'PERSP'

Planes=NewCollection("Planes")
# Add Plane
AddPlane(0,0,16,szr)
bpy.context.object.scale[0] = 0.18
bpy.context.object.rotation_euler[2] = 1.5708
bpy.context.object.location[1] = -3
ob=bpy.context.object	
MoveObjToCollection(Planes,ob)

AddPlane(0,0,-8,szr)
bpy.context.object.scale[0] = 0.05
bpy.context.object.rotation_euler[2] = 1.5708
ob=bpy.context.object	
MoveObjToCollection(Planes,ob)

AddPlane(0,0,0,szr)
bpy.ops.transform.resize(value=(1, 0.015, 1), orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(False, True, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False, release_confirm=True)
bpy.context.object.rotation_euler[0] = 1.5708
bpy.context.object.location[2] = 18
bpy.context.object.location[1] = -20
ob=bpy.context.object	
MoveObjToCollection(Planes,ob)

Pics=NewCollection("Pics")
lv=0
ps=4 # picturesize
pst=int(ps*abst) # picture-step between pics
tar=int(szr/pst)
kfs=int(frames/tar)
print("Phase I")
pl=list()

while lv <= tar:
    lv+=1
    name='PM_'+str(lv)
    picn=r.randint(1,NumPics)
    pat="F:\\00_S-DB\\01_Blender\\02_Scenes\\Museum-Script\\Pictures\\PXC_"+str(picn)+".jpg"
    xpo=hsr-lv*pst
    AddPlane(0,0,0,4)		
    # Liste mit Objekten erzeugen
    obg=bpy.context.object
    pl.append(obg)
    thk=r.uniform(0.1,0.9)
    bpy.ops.object.modifier_add(type='SOLIDIFY')
    bpy.context.object.modifiers["Solidify"].thickness = thk
    yloc=-(19-thk)
    
    bpy.context.object.location[0] = xpo
    bpy.context.object.location[1] = yloc
    bpy.context.object.location[2] = 4    
#	bpy.context.object.rotation_euler[0] = 4.53786
    bpy.context.object.rotation_euler[0] = 4.83631
    bpy.context.object.rotation_euler[1] = 3.14159
    
    mat = bpy.data.materials.new(name)
    mat.use_nodes = True
    bsdf = mat.node_tree.nodes["Principled BSDF"]
    bsdf.inputs[15].default_value = 0.104545
    texImage = mat.node_tree.nodes.new('ShaderNodeTexImage')
    texImage.image = bpy.data.images.load(pat)
    xsz=texImage.image.size[0] # width
    ysz=texImage.image.size[1] # height
    
    if xsz<xsize:
        yfa=xsize/xsz
        xsz=xsize
        ysz=ysz*yfa
        
    obg.scale[0]=xsz/1000
    obg.scale[1]=ysz/1000
    
    mat.node_tree.links.new(bsdf.inputs['Base Color'], texImage.outputs['Color'])
        
    ob=bpy.context.object	
    MoveObjToCollection(Pics,ob)
    # Assign it to object
    if ob.data.materials:
        ob.data.materials[0] = mat
    else:
        ob.data.materials.append(mat)


# Create a new material
material = bpy.data.materials.new(name="Diffuse")
material.use_nodes = True

# Remove default
material.node_tree.nodes.remove(material.node_tree.nodes.get('Principled BSDF')) #title of the existing node when materials.new
material_output = material.node_tree.nodes.get('Material Output')
diffuse = material.node_tree.nodes.new('ShaderNodeBsdfDiffuse')    #name of diffuse BSDF when added with shift+A
diffuse.inputs['Color'].default_value = (1, 0, 1, 1) #last value alpha

# link diffuse shader to material
material.node_tree.links.new(material_output.inputs[0], diffuse.outputs[0])

# set activer material to your new material
bpy.context.object.active_material = material
       
Backs=NewCollection("Backs")	   
Lights=NewCollection("Lights")
lv=0
gt=0
lac=0 # large counter
emax=len(pl)

print("Phase II")
while lv <= tar: 
    print(str(lv)+"/"+str(tar))
    lv+=1    
    gt+=1
    name='PX_'+str(lv)    
    xpo=hsr-lv*pst
    AddPlane(0,0,0,4.5)
    ob=bpy.context.object
    ob.location[0] = xpo
    ob.location[1] = -19.8
    ob.location[2] = 3.9   
    ob.rotation_euler[0] = -1.5708
    ob.rotation_euler[1] = 3.14159 
    scf=1.3
    ob.scale[0]=pl[lv-1].scale[0]*scf
    ob.scale[1]=pl[lv-1].scale[1]*scf
    ob.scale[2]=pl[lv-1].scale[2]*scf
    
    if gt>2:
        obx=ob
        ob=bpy.context.object
    else:	
        ob=bpy.context.object
        obx=ob
    
    MoveObjToCollection(Backs,ob)
    bpy.ops.object.modifier_add(type='SOLIDIFY')
    bpy.context.object.modifiers["Solidify"].thickness = 0.3
    
    # Assign it to object
    if ob.data.materials:
        ob.data.materials[0] = material
    else:
        ob.data.materials.append(material)
    # Nur jedes 2 te Licht setzen da Eve nur 128 Lichter erlaubt	
    if gt==2: 
        gt=0
        bpy.ops.object.light_add(type='AREA', radius=1, align='WORLD', location=(0,0, 0))
        bpy.context.object.location[0] = xpo
        bpy.context.object.location[1] = 0.8
        bpy.context.object.location[2] = 14    
        bpy.context.object.rotation_euler[0] = 0
        bpy.context.object.rotation_euler[1] = 0	
        bpy.context.object.data.energy = 1500
        bpy.context.object.scale[0] = 4
        bpy.context.object.scale[1] = 4
        bpy.context.object.scale[2] = 4
        bpy.context.object.data.cycles.is_portal = False
        obb=bpy.context.object
        MoveObjToCollection(Lights,obb)		          

print("Phase III")
lv=0
fn=1
fnc=int(frames/tar)
emax-=1
while lv < tar:     
    lv+=1
    if lv>tar:
        lv=int(tar)
            
    print("lv="+str(lv))
    ob=pl[lv]
    xpo=ob.location[0]
    ypo=ob.location[1]
    
    print("Got xpo: "+str(xpo))
    
    yra=+r.uniform(-15,+20)
    xpr=xpo #+r.randint(-4,+4)
    ypr=ypo+15.2+yra 
    zpr=3.5 #+r.uniform(-0,+1)
    
    cam.location = (xpr, ypr, zpr)
    cam.data.lens = 30+yra/2
    cam.data.keyframe_insert(data_path='lens', frame=fn)
        
    pos=lv+1 #+r.randint(0,1)
    if pos>emax:
        pos=emax
    if pos<1:
        pos=1
    
    print("Point at:"+str(pos))	
    Point_at(cam,pl[pos], roll=0)
    
    tw=r.randint(45,75)

    #Camera_turn_Z(cam,tw)
    
    Keyframe_LR(cam,fn)
    fn+=fnc/2
    
    xpr=xpo+r.randint(-4,+4)
    cam.location = (xpr, ypr, zpr)

    Camera_turn_Z(cam,tw)
    
    Keyframe_LR(cam,fn)
    fn+=fnc/4
    
    Camera_turn_Z(cam,-tw)
    Keyframe_LR(cam,fn)
    fn+=fnc/4