# This is a script from a Blender Campus Tutorial on how to Script a Random Color Generator
# Link to the YouTube Video: http://youtu.be/JQXIj2-gzRM
#
# It's free to use, share and to have fun with it
# If You are reuseing it in any commercial way You are allowed to do so
# However a mention or a link to Blender Campus would be very appreciated :)
# Happy coding !!



import bpy
import random

sel_obj = bpy.context.selected_objects
# get number of selected objects
array_size = len(sel_obj)

for i in range (array_size):
    
    # generate random colors (float values 0.00 - 0.99)
    r = random.random()
    g = random.random()
    b = random.random()
    
    # pick one object at a time 
    bpy.context.scene.objects.active = sel_obj[i]
    object = bpy.context.scene.objects.active
    # create a new material or override an existing one
    if not object.material_slots.values():
        name = object.name
        material = bpy.data.materials.new(name)
        object.data.materials.append(material)
    else:
        material = object.material_slots[0].material
        
    material.diffuse_color = (r, g, b)